Gecode::Int::ViewValGraph::Graph< View > Class Template Reference

View-value graph base class. More...

`#include <view-val-graph.hh>`

## Public Member Functions

| Graph (void)
| Construct graph as not yet initialized.
| operator bool (void) const
| Test whether graph has been initialized.
void | purge (void)
| Purge graph if necessary (reset information to avoid overflow).

## Protected Types

typedef Support::StaticStack< ViewNode< View > *, Region > | ViewNodeStack
| Stack used during matching.

## Protected Member Functions

void | init (Space &home, ViewNode< View > *x)
| Initialize the edges for the view node x.
bool | match (ViewNodeStack &m, ViewNode< View > *x)
| Find a matching for node x.
void | scc (void)
| Compute the strongly connected components.

## Protected Attributes

ViewNode< View > ** | view
| Array of view nodes.
ValNode< View > * | val
| Array of value nodes.
int | n_view
| Number of view nodes.
int | n_val
| Number of value nodes.
unsigned int | count
| Marking counter.

## Detailed Description

template<class View>
class Gecode::Int::ViewValGraph::Graph< View >

View-value graph base class.

Definition at line 294 of file view-val-graph.hh.

## Member Typedef Documentation

## ViewNodeStack

template<class View>

typedef Support::StaticStack<ViewNode<View>*,Region> Gecode::Int::ViewValGraph::Graph< View >::ViewNodeStack

protected

Stack used during matching.

Definition at line 307 of file view-val-graph.hh.

## Constructor & Destructor Documentation

## Graph()

template<class View>

Graph::Graph | ( | void |  | ) |

inline

Construct graph as not yet initialized.

Definition at line 40 of file graph.hpp.

## Member Function Documentation

## init()

template<class View>

void Graph::init | ( | Space & | home,
|  | ViewNode< View > * | x )

inline protected

Initialize the edges for the view node x.

Definition at line 51 of file graph.hpp.

## match()

template<class View>

bool Graph::match | ( | ViewNodeStack & | m,
|  | ViewNode< View > * | x )

inline protected

Find a matching for node x.

Definition at line 87 of file graph.hpp.

## scc()

template<class View>

void Graph::scc | ( | void |  | ) |

inline protected

Compute the strongly connected components.

Definition at line 142 of file graph.hpp.

## operator bool()

template<class View>

Graph::operator bool | ( | void |  | ) | const

inline

Test whether graph has been initialized.

Definition at line 45 of file graph.hpp.

## purge()

template<class View>

void Graph::purge | ( | void |  | ) |

inline

Purge graph if necessary (reset information to avoid overflow).

Definition at line 130 of file graph.hpp.

## Member Data Documentation

## view

template<class View>

ViewNode<View>** Gecode::Int::ViewValGraph::Graph< View >::view

protected

Array of view nodes.

Definition at line 297 of file view-val-graph.hh.

## val

template<class View>

ValNode<View>* Gecode::Int::ViewValGraph::Graph< View >::val

protected

Array of value nodes.

Definition at line 299 of file view-val-graph.hh.

## n_view

template<class View>

int Gecode::Int::ViewValGraph::Graph< View >::n_view

protected

Number of view nodes.

Definition at line 301 of file view-val-graph.hh.

## n_val

template<class View>

int Gecode::Int::ViewValGraph::Graph< View >::n_val

protected

Number of value nodes.

Definition at line 303 of file view-val-graph.hh.

## count

template<class View>

unsigned int Gecode::Int::ViewValGraph::Graph< View >::count

protected

Marking counter.

Definition at line 305 of file view-val-graph.hh.

The documentation for this class was generated from the following files:

- gecode/int/view-val-graph.hh
- gecode/int/view-val-graph/graph.hpp